// LORE

import { world, system, Player, BlockPermutation, ItemStack, EquipmentSlot } from "@minecraft/server";

var roxlore = "hi"

class loreItem {
    constructor(itemId, lore) {
        this.itemId = itemId;
        this.lore = lore;
    }
}

const ItemArray = [
    new loreItem("dotviii:sword_chapterone_roxxane", ['§9When Used:\n\n - Launches the user in the air.\n', '§9 - Use again midair to slam into ground§9.', '§eMust be used RIGHT AFTER launching yourself.']),
    new loreItem("dotviii:sword_chapterone_dubby", ['§9When held in main hand:', '§9\n - User gains §2Natural Thorns§9.']),
    new loreItem("dotviii:sword_chapterone_legatus", ['§9When Used:\n\n - Summons Hellfire around user.', '§eUser must be on ground when used.', '§9\n - Inflicts Wither on hit.', '§eProvides Immunity to Legatus Rune Attacks']),
    new loreItem("dotviii:sword_chapterone_prismatica", ['§9When Placed:', '\n §9- Summons a Prismatic Scythe.']),
    new loreItem("dotviii:disc_boss_faevia", ['§f\nUse on Jukebox to play disk', '§fUse Disc again on Jukebox to stop playback.']),
    new loreItem("dotviii:disc_boss_triox", ['§f\nUse on Jukebox to play disk', '§fUse Disc again on Jukebox to stop playback.']),
    new loreItem("dotviii:disc_boss_roxxane", ['§f\nUse on Jukebox to play disk', '§fUse Disc again on Jukebox to stop playback.']),
    new loreItem("dotviii:disc_boss_legatus", ['§f\nUse on Jukebox to play disk', '§fUse Disc again on Jukebox to stop playback.']),
    new loreItem("dotviii:disc_bonustrack_newtoneofhymn", ['§f\nUse on Jukebox to play disk', '§fUse Disc again on Jukebox to stop playback.', '\n§eBonus Track']),
    new loreItem("dotviii:disc_bonustrack_dubtrox", ['§f\nUse on Jukebox to play disk', '§fUse Disc again on Jukebox to stop playback.', '\n§eBonus Track']),
]

system.runInterval(() => { // Lore Controls
    for (const player of world.getPlayers()) { // Gets all players
        const playerContainer = player.getComponent("inventory").container; //
        for (let i = 0; i < playerContainer.size; i++) {
            const item = playerContainer.getItem(i);
            const findLore = ItemArray.find(x => x.itemId == item?.typeId);
            const lore = item?.getLore();
            if (!findLore || !item?.amount || lore?.length != 0) continue;
            item.setLore(findLore.lore);
            playerContainer.setItem(i, item);
        }
    }
}, 1);
// Weapon Functions



SwordMechanicsHITVolIII(true)
SwordMechanicsINTERACTVolIII(true);


// Roxxanes Weapon


function SwordMechanicsINTERACTVolIII() { // Sword USE Mechanics
    world.afterEvents.itemUse.subscribe(({ source }) => {
        const equippable = source.getComponent("equippable");
        const item = equippable.getEquipment(EquipmentSlot.Mainhand);
        if (!item) return
        switch (item.typeId) {
            case "dotviii:sword_chapterone_roxxane": //Roxxane's Sword
                if (item.typeId === "dotviii:sword_chapterone_roxxane" && !source.hasTag('slamcheck') && !source.hasTag('cooldown_sword_rox')) {
                    source.applyKnockback(0, 0, 0, 1.5);
                    source.addTag('slamcheck')
                    source.addTag('cooldown_sword_rox')
                    source.runCommandAsync('playsound roxxane.swordslam1 @a[r=12] ~ ~ ~')
                    source.runCommandAsync('playanimation @s animation.roxxane_valkyrie.slam_sword_1')
                    source.runCommandAsync('particle minecraft:knockback_roar_particle_setup ~ ~ ~')
                    break;
                }
                else if (item.typeId === "dotviii:sword_chapterone_roxxane" && !source.isOnGround && source.hasTag('slamcheck')) {
                    source.applyKnockback(0, 0, 0, -10)
                    source.runCommandAsync('function chapterone/mechanics_swords/roxxanesword')
                    source.runCommandAsync('playsound roxxane.swordslam2 @a[r=12] ~ ~ ~')
                    source.runCommandAsync('playanimation @s animation.roxxane_valkyrie.slam_sword_2')
                    break;
                }
            case "dotviii:sword_chapterone_legatus": // Legatus Sword
                if (item.typeId === "dotviii:sword_chapterone_legatus" && !source.hasTag('cooldown_sword_legatus') && source.isOnGround) {
                    source.runCommandAsync('function chapterone/mechanics_swords/legatussword')
                    source.addTag('cooldown_sword_legatus')
                    break
                }
            case "dotviii:bossmusicmuter":
                if (item.typeId === "dotviii:bossmusicmuter" && !source.hasTag('mutebossmusic')) {
                    source.runCommandAsync('title @s actionbar §eBoss Music Disabled')
                    source.runCommandAsync('playsound mob.irongolem.hit @s ~ ~ ~')
                    source.addTag('mutebossmusic')
                    break
                }
                else if (item.typeId === "dotviii:bossmusicmuter" && source.hasTag('mutebossmusic')) {
                    source.runCommandAsync('title @s actionbar §eBoss Music Enabled')
                    source.runCommandAsync('playsound mob.irongolem.hit @s ~ ~ ~')
                    source.removeTag('mutebossmusic')
                    break
                }
        }
    });
}

function SwordMechanicsHITVolIII() { // Sword HIT Mechanics
    world.afterEvents.entityHitEntity.subscribe((data) => {
        for (var player of world.getPlayers()) {
        }
        const victim = data.hitEntity
        const hitter = data.damagingEntity
        const equippable = player.getComponent("equippable")
        let mainhand = equippable.getEquipment("Mainhand")
        if (!mainhand) return
        switch (mainhand.typeId) {
            case "dotviii:sword_chapterone_dubby":
                if (mainhand.typeId === "dotviii:sword_chapterone_dubby" && victim.typeId === "minecraft:player") {
                    hitter.applyDamage(15)
                    break
                }
            case "dotviii:sword_chapterone_legatus":
                if (mainhand.typeId === "dotviii:sword_chapterone_legatus" && victim.typeId != "minecraft:player" && victim.typeId != "dotviii:legatus") {
                    victim.addTag('effect_erianfire')
                    break
                }
        }
    })
}

SwordMechanicsPLACEVolIII()
function SwordMechanicsPLACEVolIII() { //Sword HIT Mechanics
    world.beforeEvents.itemUseOn.subscribe((eventData) => {
        const { source: player, itemStack: item, block } = eventData;
        switch (item.typeId) {
            case "dotviii:sword_chapterone_prismatica":
                if (item?.typeId == "dotviii:sword_chapterone_prismatica") {
                    if (player.lastTick == undefined) { player.lastTick = 0 }
                    if (system.currentTick - player.lastTick > 3) {
                        player.runCommandAsync(`summon dotviii:primoirdial_faescythe ${block.x} ${block.y + 1} ${block.z}`);
                        player.lastTick = system.currentTick;
                    }
                }
        }
    });
}

CustomRecordsVolIII()
function CustomRecordsVolIII() { //Custom Records
    world.beforeEvents.itemUseOn.subscribe((eventData) => {
        const { source: player, itemStack: item, block } = eventData;
        switch (item.typeId) {
            case "dotviii:disc_boss_faevia":
                if (item?.typeId == "dotviii:disc_boss_faevia" && block.permutation.matches('minecraft:jukebox') && !player.hasTag('playingcustomdisk')) {
                    if (player.lastTick == undefined) { player.lastTick = 0 }
                    if (system.currentTick - player.lastTick > 3) {
                        player.runCommandAsync(`title @s actionbar Now playing: ItsDarkwolf6 - Token of Light `);
                        player.runCommandAsync(`playsound bosstheme.faevia @a ${block.x} ${block.y} ${block.z}`)
                        player.runCommandAsync('tag @s add playingcustomdisk')
                        player.lastTick = system.currentTick;
                    }
                }
                else if (item?.typeId == "dotviii:disc_boss_faevia" && block.permutation.matches('minecraft:jukebox') && player.hasTag('playingcustomdisk')) {
                    player.runCommandAsync(`function stopcustomdiscs_iii`);
                    player.runCommandAsync('tag @s remove playingcustomdisk');
                }
            case "dotviii:disc_boss_triox":
                if (item?.typeId == "dotviii:disc_boss_triox" && block.permutation.matches('minecraft:jukebox') && !player.hasTag('playingcustomdisk')) {
                    if (player.lastTick == undefined) { player.lastTick = 0 }
                    if (system.currentTick - player.lastTick > 3) {
                        player.runCommandAsync(`title @s actionbar Now playing: ItsDarkwolf6 - Legend Reborn`);
                        player.runCommandAsync(`playsound bosstheme.triox @a ${block.x} ${block.y} ${block.z}`)
                        player.runCommandAsync('tag @s add playingcustomdisk')
                        player.lastTick = system.currentTick;
                    }
                }
                else if (item?.typeId == "dotviii:disc_boss_triox" && block.permutation.matches('minecraft:jukebox') && player.hasTag('playingcustomdisk')) {
                    player.runCommandAsync(`function stopcustomdiscs_iii`);
                    player.runCommandAsync('tag @s remove playingcustomdisk');
                }
            case "dotviii:disc_boss_roxxane":
                if (item?.typeId == "dotviii:disc_boss_roxxane" && block.permutation.matches('minecraft:jukebox') && !player.hasTag('playingcustomdisk')) {
                    if (player.lastTick == undefined) { player.lastTick = 0 }
                    if (system.currentTick - player.lastTick > 3) {
                        player.runCommandAsync(`title @s actionbar Now playing: ItsDarkwolf6 - Archangel of Envy`);
                        player.runCommandAsync(`playsound bosstheme.roxxane @a ${block.x} ${block.y} ${block.z}`)
                        player.runCommandAsync('tag @s add playingcustomdisk')
                        player.lastTick = system.currentTick;
                    }
                }
                else if (item?.typeId == "dotviii:disc_boss_roxxane" && block.permutation.matches('minecraft:jukebox') && player.hasTag('playingcustomdisk')) {
                    player.runCommandAsync(`function stopcustomdiscs_iii`);
                    player.runCommandAsync('tag @s remove playingcustomdisk');
                }
            case "dotviii:disc_boss_legatus":
                if (item?.typeId == "dotviii:disc_boss_legatus" && block.permutation.matches('minecraft:jukebox') && !player.hasTag('playingcustomdisk')) {
                    if (player.lastTick == undefined) { player.lastTick = 0 }
                    if (system.currentTick - player.lastTick > 3) {
                        player.runCommandAsync(`title @s actionbar Now playing: ItsDarkwolf6 - Archdemon of Legacy`);
                        player.runCommandAsync(`playsound bosstheme.legatus @a ${block.x} ${block.y} ${block.z}`)
                        player.runCommandAsync('tag @s add playingcustomdisk')
                        player.lastTick = system.currentTick;
                    }
                }
                else if (item?.typeId == "dotviii:disc_boss_legatus" && block.permutation.matches('minecraft:jukebox') && player.hasTag('playingcustomdisk')) {
                    player.runCommandAsync(`function stopcustomdiscs_iii`);
                    player.runCommandAsync('tag @s remove playingcustomdisk');
                }
                case "dotviii:disc_bonustrack_newtoneofhymn":
                    if (item?.typeId == "dotviii:disc_bonustrack_newtoneofhymn" && block.permutation.matches('minecraft:jukebox') && !player.hasTag('playingcustomdisk')) {
                        if (player.lastTick == undefined) { player.lastTick = 0 }
                        if (system.currentTick - player.lastTick > 3) {
                            player.runCommandAsync(`title @s actionbar Now playing: RickyTheGamer - The New Hymn`);
                            player.runCommandAsync(`playsound bonustrack.thenewhymn @a ${block.x} ${block.y} ${block.z}`)
                            player.runCommandAsync('tag @s add playingcustomdisk')
                            player.lastTick = system.currentTick;
                        }
                    }
                    else if (item?.typeId == "dotviii:disc_bonustrack_newtoneofhymn" && block.permutation.matches('minecraft:jukebox') && player.hasTag('playingcustomdisk')) {
                        player.runCommandAsync(`function stopcustomdiscs_iii`);
                        player.runCommandAsync('tag @s remove playingcustomdisk');
                    }
                    case "dotviii:disc_bonustrack_dubtrox":
                        if (item?.typeId == "dotviii:disc_bonustrack_dubtrox" && block.permutation.matches('minecraft:jukebox') && !player.hasTag('playingcustomdisk')) {
                            if (player.lastTick == undefined) { player.lastTick = 0 }
                            if (system.currentTick - player.lastTick > 3) {
                                player.runCommandAsync(`title @s actionbar Now playing: RickyTheGamer - Dubtrox`);
                                player.runCommandAsync(`playsound bonustrack.dubtrox @a ${block.x} ${block.y} ${block.z}`)
                                player.runCommandAsync('tag @s add playingcustomdisk')
                                player.lastTick = system.currentTick;
                            }
                        }
                        else if (item?.typeId == "dotviii:disc_bonustrack_dubtrox" && block.permutation.matches('minecraft:jukebox') && player.hasTag('playingcustomdisk')) {
                            player.runCommandAsync(`function stopcustomdiscs_iii`);
                            player.runCommandAsync('tag @s remove playingcustomdisk');
                        }
        }
    });
}